`timescale 1ns / 1ps

module test_fifo_v;

	// Inputs
	reg clk;
	reg reset;
	reg [15:0] input_data;
	reg wen;
	reg ren;

	// Outputs
	wire [15:0] output_data;
	wire empty;
	wire full;

	// Instantiate the Unit Under Test (UUT)
	fifo uut (
		.clk(clk), 
		.reset(reset), 
		.input_data(input_data), 
		.wen(wen), 
		.ren(ren), 
		.output_data(output_data), 
		.empty(empty), 
		.full(full)
	);

	initial begin
		// Initialize Inputs
		clk = 0;
		reset = 1;
		input_data = 0;
		wen = 0;
		ren = 0;

		// Wait 100 ns for global reset to finish
		#100;

		// Add stimulus here
		reset = 0;
		
		// fill the fifo
		input_data = 1; wen = 1; #10; wen = 0; #10;
		input_data = 2; wen = 1; #10; wen = 0; #10;
		input_data = 3; wen = 1; #10; wen = 0; #10;
		input_data = 4; wen = 1; #10; wen = 0; #10;
		input_data = 5; wen = 1; #10; wen = 0; #10;
		input_data = 6; wen = 1; #10; wen = 0; #10;
		input_data = 7; wen = 1; #10; wen = 0; #10;
		input_data = 8; wen = 1; #10; wen = 0; #10;
		input_data = 9; wen = 1; #10; wen = 0; #10;
		input_data = 10; wen = 1; #10; wen = 0; #10;
		input_data = 11; wen = 1; #10; wen = 0; #10;
		input_data = 12; wen = 1; #10; wen = 0; #10;
		input_data = 13; wen = 1; #10; wen = 0; #10;
		input_data = 14; wen = 1; #10; wen = 0; #10;
		input_data = 15; wen = 1; #10; wen = 0; #10;
		input_data = 16; wen = 1; #10; wen = 0; #10;
		// overfull - should wrap around
		input_data = 17; wen = 1; #10; wen = 0; #10;

		// empty
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		
		// refill	
		input_data = 1; wen = 1; #10; wen = 0; #10;
		input_data = 2; wen = 1; #10; wen = 0; #10;
		ren = 1; #10; ren = 0; #10; 
		input_data = 3; wen = 1; #10; wen = 0; #10;
		input_data = 4; wen = 1; #10; wen = 0; #10;
		ren = 1; #10; ren = 0; #10; 
		input_data = 5; wen = 1; #10; wen = 0; #10;
		input_data = 6; wen = 1; #10; wen = 0; #10;
		ren = 1; #10; ren = 0; #10; 
		input_data = 7; wen = 1; #10; wen = 0; #10;
		input_data = 8; wen = 1; #10; wen = 0; #10;
		input_data = 9; wen = 1; #10; wen = 0; #10;
		ren = 1; #10; ren = 0; #10; 
		input_data = 10; wen = 1; #10; wen = 0; #10;
		input_data = 11; wen = 1; #10; wen = 0; #10;
		input_data = 12; wen = 1; #10; wen = 0; #10;
		ren = 1; #10; ren = 0; #10; 
		input_data = 13; wen = 1; #10; wen = 0; #10;
		input_data = 14; wen = 1; #10; wen = 0; #10;
		ren = 1; #10; ren = 0; #10; 
		input_data = 15; wen = 1; #10; wen = 0; #10;
		input_data = 16; wen = 1; #10; wen = 0; #10;
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		input_data = 17; wen = 1; #10; wen = 0; #10;
		input_data = 18; wen = 1; #10; wen = 0; #10;
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
		ren = 1; #10; ren = 0; #10; 
	end
	always
	begin
		#5 clk = ~clk;
	end      
endmodule

