`timescale 1ns / 1ps


module test_keygrid_4x4_v;

	// Inputs
	reg [15:0] presses;
	reg [3:0] column_ins;

	// Outputs
	wire [3:0] row_outs;

	// Instantiate the Unit Under Test (UUT)
	keygrid_4x4 uut (
		.presses(presses), 
		.column_ins(column_ins), 
		.row_outs(row_outs)
	);

	initial begin
		// Initialize Inputs
		presses = 0;
		column_ins = 0;

		// Wait 100 ns for global reset to finish
		#100;
        
		// Add stimulus here
		column_ins = 4'b1111;
		#5;
		presses = 16'b0000000000000001;
		#5;
		presses = 16'b0000000000010001;
		#5;
		presses = 16'b0000000000000011;
		#5;
		presses = 16'b1000000000000001;
		#5;
		presses = 16'b1000100000100001;
		#5;
		presses = 16'b1000000000000001;
		#5;
		column_ins = 4'b0001;
		#5;
		column_ins = 4'b0010;
		#5;
		column_ins = 4'b0100;
		#5;
		column_ins = 4'b1000;
	end
      
endmodule

